#ifndef F_CPU
#define F_CPU 16000000UL
#endif
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>  /* for sei() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"
uint16_t TEMP=0;
char in_c(char bit)
{
    // read logic level of port-C's pin
    DDRC &= ~(1<<bit);
    return ((PINC & (1<<bit))>>bit);    
} 

void out_c(char bit, char val)
{
    // write logic level to port-C's pin
    DDRC |= 1<<bit;
    if(val)
        PORTC |= 1<<bit;
    else
        PORTC &= ~(1<<bit);

}


usbMsgLen_t usbFunctionSetup(uchar data[8])
{
    usbRequest_t *rq = (void *)data;
    static uchar dataBuffer[2];  /* must stay valid when usbFunctionSetup returns */
    if (rq->bRequest == 9)
    {
	dataBuffer[0] = TEMP/256;
	dataBuffer[1] = TEMP%256;
        usbMsgPtr = dataBuffer;
        return 2;
    }

    return 0;   /* default for not implemented requests: return no data back to host */
}

main()
{
    DDRC  = 0b00000111;  // PC0..PC2 = Output, PC3..PC5 = Input
    PORTC = 0b00000000;  // PC7..PC0 = 0
//    PORTC |= (1 << 3);   // Enable pull-up at PC3
    DDRD  = 0b00001000;
    PORTD = 0b00000000;
 //   out_c(2,1);
    unsigned char i;
/*    for(;;)
    {
	x = read_adc(3);
	for(i=0;i<100;i++)
	{
		TEMP=TEMP+ADCW;
	}
	TEMP/=400;*/
	//DDRD=0xFF;
//	ACSR=0x80; // Analog Comparator: Off
//	SFIOR=0x00;
	usbInit();
	usbDeviceDisconnect();  /* enforce re-enumeration, do this while interrupts are disabled! */
	 _delay_ms(300);
	usbDeviceConnect();
	sei();
	while (1)
	{
		usbPoll();
		ADMUX=0xC0; // ADC Voltage Reference: Int., cap. on AREF
		ADCSRA=0x87; // ADC Clock frequency: 62.500 kHz
		ADMUX|= 3; // 3 bcz i am using adc channel 3

		// Delay needed for the stabilization of the ADC input voltage

		_delay_us(200);

		ADCSRA|=0x40; //Initialize ADC in single conversion mode

		while ((ADCSRA & 0x10)==0); // Wait for the AD conversion to complete
		ADCSRA|=0x20; //Initiatialize free running mode
		TEMP=0;
		for(i=0;i<100;i++)
		{
			TEMP=TEMP+ADCW;
	//		_delay_us(10000);
		}
		TEMP/=400; 
		TEMP+=10;
	/*	if(TEMP>=0&&TEMP<=10)
		{
			out_c(5,1); //White
			out_c(0,0);
			out_c(2,0);
			out_c(1,0);
			out_c(4,0);
		}
		else if(TEMP>10&&TEMP<=20)
		{
			out_c(4,1); //blue
			out_c(0,0);
			out_c(2,0);
			out_c(1,0);
			out_c(5,0);
		}
		else if(TEMP>20&&TEMP<=27)
		{
			out_c(2,1); //green
			out_c(0,0);
			out_c(4,0);
			out_c(1,0);
			out_c(5,0);
		}
		else if(TEMP >27&&TEMP<=40)
		{
			out_c(0,1); //yel
			out_c(1,0);
			out_c(2,0);
			out_c(4,0);
			out_c(5,0);
		}
		else if(TEMP>40)
		{
			out_c(1,1); //red
			out_c(0,0);
			out_c(2,0);
			out_c(4,0);
			out_c(5,0);
		}*/
    }   
    return 0;
}
